#!/usr/bin/env python
from SimPy.Simulation  import *
from random import expovariate, seed, uniform

""" bank08: A counter with a random service time
Customers which renege.
"""
class Source(Process):
    """ Source generates customers randomly"""

    def generate(self,number,interval):       
        for i in range(number):
            c = Customer(name = "Customer%02d"%(i,))
            activate(c,c.visit(timeInBank=12.0))
            t = expovariate(1.0/interval)
            yield hold,self,t

class Customer(Process):
    """ Customer arrives, is served and leaves """
        
    def visit(self,timeInBank=0):       
        arrive=now()
        print "%7.4f %s: Here I am     "%(now(),self.name)
        yield (request,self,counter),(hold,self,Customer.patience())
        if self.acquired(counter):
            wait=now()-arrive
            print "%7.4f %s: Waited %6.3f"%(now(),self.name,wait)
            tib = expovariate(1.0/timeInBank)            
            yield hold,self,tib                          
            yield release,self,counter
            print "%7.4f %s: Finished      "%(now(),self.name)
        else:
            wait=now()-arrive
            print "%7.4f %s: Reneged after %6.3f"%(now(),self.name,wait)            
        
    def fpatience(minpatience=0,maxpatience=10000000000):
        while True:
            yield uniform(minpatience,maxpatience)
    fpatience=staticmethod(fpatience)

def model(theseed):                                   
    global counter                                   
    seed(theseed)
    counter = Resource(name="Karen") 
    pat=Customer.fpatience(minpatience=1,maxpatience=3)
    Customer.patience=pat.next
    initialize()
    source = Source('Source')
    activate(source,source.generate(5,interval=10.0),0.0)
    simulate(until=400.0)

model(theseed=12345)                               

